#!/usr/bin/env bash
#   *** validation ***
scripts/run-validator-tests.sh
scripts/run-checker-tests.sh

#    *** tests ***
mkdir -p tests
echo "Generating test #3"
scripts/gen-input-via-stdout.sh "wine files/genRnd.exe -t 5 -a 10 -b 10 -s 10" "tests/03" 3
echo "Generating test #4"
scripts/gen-input-via-stdout.sh "wine files/genRnd.exe -t 5 -a 2 -b 2 -s 10" "tests/04" 4
echo "Generating test #5"
scripts/gen-input-via-stdout.sh "wine files/genRnd.exe -t 5 -a 1 -b 4 -s 9" "tests/05" 5
echo "Generating test #6"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 5 -a 10 -b 10 -s 10 -mode bf" "tests/06" 6
echo "Generating test #7"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 5 -a 10 -b 10 -s 10 -mode hs" "tests/07" 7
echo "Generating test #8"
scripts/gen-input-via-stdout.sh "wine files/genRnd.exe -t 100 -a 100 -b 100 -s 100" "tests/08" 8
echo "Generating test #9"
scripts/gen-input-via-stdout.sh "wine files/genRnd.exe -t 100 -a 10 -b 10 -s 100" "tests/09" 9
echo "Generating test #10"
scripts/gen-input-via-stdout.sh "wine files/genRnd.exe -t 100 -a 4 -b 40 -s 99" "tests/10" 10
echo "Generating test #11"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 100 -a 100 -b 5 -s 100 -mode bf" "tests/11" 11
echo "Generating test #12"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 100 -a 100 -b 100 -s 100 -mode bs" "tests/12" 12
echo "Generating test #13"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 100 -a 10 -b 10 -s 100 -mode hf" "tests/13" 13
echo "Generating test #14"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 100 -a 5 -b 20 -s 100 -mode hs" "tests/14" 14
echo "Generating test #15"
scripts/gen-input-via-stdout.sh "wine files/genRnd3.exe -t 100 -a 1000 -b 1000 -s 1000 -mode rnd" "tests/15" 15
echo "Generating test #16"
scripts/gen-input-via-stdout.sh "wine files/genRnd3.exe -t 300 -a 1000000000 -b 1000000000 -s 1000000000 -mode rnd" "tests/16" 16
echo "Generating test #17"
scripts/gen-input-via-stdout.sh "wine files/genRnd3.exe -t 400 -a 1000000000 -b 1000000000 -s 1000000000 -mode less" "tests/17" 17
echo "Generating test #18"
scripts/gen-input-via-stdout.sh "wine files/genRnd3.exe -t 500 -a 1000000000 -b 1000000000 -s 1000000000 -mode more" "tests/18" 18
echo "Generating test #19"
scripts/gen-input-via-stdout.sh "wine files/genRnd3.exe -t 500 -a 1000000000 -b 10000000 -s 1000000000 -mode more" "tests/19" 19
echo "Generating test #20"
scripts/gen-input-via-stdout.sh "wine files/genRnd3.exe -t 500 -a 10000000 -b 1000000000 -s 1000000000 -mode less" "tests/20" 20
echo "Generating test #21"
scripts/gen-input-via-stdout.sh "wine files/genRnd4.exe -t 100 -a 100000 -b 1000 -s 1000000 -mode rnd" "tests/21" 21
echo "Generating test #22"
scripts/gen-input-via-stdout.sh "wine files/genRnd4.exe -t 300 -a 1000000 -b 10000000 -s 1000000000 -mode rnd" "tests/22" 22
echo "Generating test #23"
scripts/gen-input-via-stdout.sh "wine files/genRnd4.exe -t 400 -a 10000000 -b 1000 -s 10000000 -mode less" "tests/23" 23
echo "Generating test #24"
scripts/gen-input-via-stdout.sh "wine files/genRnd4.exe -t 500 -a 100000000 -b 1000000000 -s 1000000000 -mode more" "tests/24" 24
echo "Generating test #25"
scripts/gen-input-via-stdout.sh "wine files/genRnd4.exe -t 500 -a 1000000000 -b 10000000 -s 1000000000 -mode more" "tests/25" 25
echo "Generating test #26"
scripts/gen-input-via-stdout.sh "wine files/genRnd4.exe -t 500 -a 10000000 -b 1000000000 -s 1000000000 -mode less" "tests/26" 26
echo "Generating test #27"
scripts/gen-input-via-stdout.sh "wine files/genRnd.exe -t 500 -a 1 -b 1000 -s 100000" "tests/27" 27
echo "Generating test #28"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 500 -a 1 -b 1000000000 -s 1000000000 -mode bs" "tests/28" 28
echo "Generating test #29"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 500 -a 1 -b 1000000000 -s 1000000000 -mode hf dbgdj" "tests/29" 29
echo "Generating test #30"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 500 -a 1 -b 1000000000 -s 1000000000 -mode hf d893gdj" "tests/30" 30
echo "Generating test #31"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 500 -a 1 -b 1000000000 -s 1000000000 -mode hs" "tests/31" 31
echo "Generating test #32"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 500 -a 1 -b 1000000000 -s 1000000000 -mode bf" "tests/32" 32
echo "Generating test #33"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 500 -a 1000000000 -b 1000000000 -s 1000000000 -mode bs" "tests/33" 33
echo "Generating test #34"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 500 -a 1000000000 -b 1000000000 -s 1000000000 -mode hf dbgdj" "tests/34" 34
echo "Generating test #35"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 500 -a 1000000000 -b 1000000000 -s 1000000000 -mode hf d893gdj" "tests/35" 35
echo "Generating test #36"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 500 -a 1000000000 -b 1000000000 -s 1000000000 -mode hs" "tests/36" 36
echo "Generating test #37"
scripts/gen-input-via-stdout.sh "wine files/genChad.exe -t 500 -a 1000000000 -b 1000000000 -s 1000000000 -mode bf" "tests/37" 37
echo "Generating test #38"
scripts/gen-input-via-stdout.sh "wine files/genRnd.exe -t 500 -a 3300872 -b 321385082 -s 962575958 aee79daa29e6ca9412844012ebe3942c" "tests/38" 38
echo "Generating test #39"
scripts/gen-input-via-stdout.sh "wine files/genRnd.exe -t 500 -a 162539 -b 526443298 -s 645201502 0eb464e4aed8ecdd935cb29e43b97578" "tests/39" 39
echo "Generating test #40"
scripts/gen-input-via-stdout.sh "wine files/genRnd.exe -t 500 -a 6113066 -b 756472054 -s 616999042 5a6de618146a66f3f053055055c892b3" "tests/40" 40
echo "Generating test #41"
scripts/gen-input-via-stdout.sh "wine files/genRnd.exe -t 500 -a 810141579 -b 13081791 -s 543273194 19d86f45d2209856e68bc14606211b3d" "tests/41" 41
echo "Generating test #42"
scripts/gen-input-via-stdout.sh "wine files/genRnd.exe -t 500 -a 76 -b 63 -s 744801060 a8c98a527790fa323a4022bc8215216b" "tests/42" 42
echo "Generating test #43"
scripts/gen-input-via-stdout.sh "wine files/genRnd.exe -t 500 -a 20 -b 15 -s 114079911 a27c8ff5eb2232277d0a232f51af005b" "tests/43" 43
echo ""
echo "Generating answer for test #1"
scripts/gen-answer.sh tests/01 tests/01.a "tests" "0"
echo ""
echo "Generating answer for test #2"
scripts/gen-answer.sh tests/02 tests/02.a "tests" "0"
echo ""
echo "Generating answer for test #3"
scripts/gen-answer.sh tests/03 tests/03.a "tests" "1"
echo ""
echo "Generating answer for test #4"
scripts/gen-answer.sh tests/04 tests/04.a "tests" "1"
echo ""
echo "Generating answer for test #5"
scripts/gen-answer.sh tests/05 tests/05.a "tests" "1"
echo ""
echo "Generating answer for test #6"
scripts/gen-answer.sh tests/06 tests/06.a "tests" "1"
echo ""
echo "Generating answer for test #7"
scripts/gen-answer.sh tests/07 tests/07.a "tests" "1"
echo ""
echo "Generating answer for test #8"
scripts/gen-answer.sh tests/08 tests/08.a "tests" "2"
echo ""
echo "Generating answer for test #9"
scripts/gen-answer.sh tests/09 tests/09.a "tests" "2"
echo ""
echo "Generating answer for test #10"
scripts/gen-answer.sh tests/10 tests/10.a "tests" "2"
echo ""
echo "Generating answer for test #11"
scripts/gen-answer.sh tests/11 tests/11.a "tests" "2"
echo ""
echo "Generating answer for test #12"
scripts/gen-answer.sh tests/12 tests/12.a "tests" "2"
echo ""
echo "Generating answer for test #13"
scripts/gen-answer.sh tests/13 tests/13.a "tests" "2"
echo ""
echo "Generating answer for test #14"
scripts/gen-answer.sh tests/14 tests/14.a "tests" "2"
echo ""
echo "Generating answer for test #15"
scripts/gen-answer.sh tests/15 tests/15.a "tests" "3"
echo ""
echo "Generating answer for test #16"
scripts/gen-answer.sh tests/16 tests/16.a "tests" "3"
echo ""
echo "Generating answer for test #17"
scripts/gen-answer.sh tests/17 tests/17.a "tests" "3"
echo ""
echo "Generating answer for test #18"
scripts/gen-answer.sh tests/18 tests/18.a "tests" "3"
echo ""
echo "Generating answer for test #19"
scripts/gen-answer.sh tests/19 tests/19.a "tests" "3"
echo ""
echo "Generating answer for test #20"
scripts/gen-answer.sh tests/20 tests/20.a "tests" "3"
echo ""
echo "Generating answer for test #21"
scripts/gen-answer.sh tests/21 tests/21.a "tests" "4"
echo ""
echo "Generating answer for test #22"
scripts/gen-answer.sh tests/22 tests/22.a "tests" "4"
echo ""
echo "Generating answer for test #23"
scripts/gen-answer.sh tests/23 tests/23.a "tests" "4"
echo ""
echo "Generating answer for test #24"
scripts/gen-answer.sh tests/24 tests/24.a "tests" "4"
echo ""
echo "Generating answer for test #25"
scripts/gen-answer.sh tests/25 tests/25.a "tests" "4"
echo ""
echo "Generating answer for test #26"
scripts/gen-answer.sh tests/26 tests/26.a "tests" "4"
echo ""
echo "Generating answer for test #27"
scripts/gen-answer.sh tests/27 tests/27.a "tests" "5"
echo ""
echo "Generating answer for test #28"
scripts/gen-answer.sh tests/28 tests/28.a "tests" "5"
echo ""
echo "Generating answer for test #29"
scripts/gen-answer.sh tests/29 tests/29.a "tests" "5"
echo ""
echo "Generating answer for test #30"
scripts/gen-answer.sh tests/30 tests/30.a "tests" "5"
echo ""
echo "Generating answer for test #31"
scripts/gen-answer.sh tests/31 tests/31.a "tests" "5"
echo ""
echo "Generating answer for test #32"
scripts/gen-answer.sh tests/32 tests/32.a "tests" "5"
echo ""
echo "Generating answer for test #33"
scripts/gen-answer.sh tests/33 tests/33.a "tests" "6"
echo ""
echo "Generating answer for test #34"
scripts/gen-answer.sh tests/34 tests/34.a "tests" "6"
echo ""
echo "Generating answer for test #35"
scripts/gen-answer.sh tests/35 tests/35.a "tests" "6"
echo ""
echo "Generating answer for test #36"
scripts/gen-answer.sh tests/36 tests/36.a "tests" "6"
echo ""
echo "Generating answer for test #37"
scripts/gen-answer.sh tests/37 tests/37.a "tests" "6"
echo ""
echo "Generating answer for test #38"
scripts/gen-answer.sh tests/38 tests/38.a "tests" "6"
echo ""
echo "Generating answer for test #39"
scripts/gen-answer.sh tests/39 tests/39.a "tests" "6"
echo ""
echo "Generating answer for test #40"
scripts/gen-answer.sh tests/40 tests/40.a "tests" "6"
echo ""
echo "Generating answer for test #41"
scripts/gen-answer.sh tests/41 tests/41.a "tests" "6"
echo ""
echo "Generating answer for test #42"
scripts/gen-answer.sh tests/42 tests/42.a "tests" "6"
echo ""
echo "Generating answer for test #43"
scripts/gen-answer.sh tests/43 tests/43.a "tests" "6"
echo ""

