#include "testlib.h"

using namespace std;

int gcd(int a, int b) {
    return b ? gcd(b, a % b) : a;
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    int t = opt<int>("t"), a = opt<int>("a"), b = opt<int>("b"), s = opt<int>("s");
    auto mode = opt<string>("mode");
    println(t);
    for (int i = 0; i < t; i++) {
        if (mode == "rnd" || !rnd.next(50)) {
            int ai = 0, bi = 0;
            long long si = s + 1;
            while (si > s) {
                int lim = max(sqrt(a), sqrt(b));
                ai = rnd.next(1, min(a, lim)), bi = rnd.next(1, min(b, lim));
                si = static_cast<long long>(ai) * bi / gcd(ai, bi);
            }
            println(ai, bi, si);
        } else if (mode == "less") {
            int si;
            vector<int> opts;
            while (true) {
                si = rnd.wnext(s / 2, s, 10);
                opts.clear();
                for (int q = 1; q * q <= si; q++) {
                    if (si % q == 0) opts.push_back(q);
                }
                if (!opts.empty()) {
                    int ai = opts[rnd.next(opts.size())], bi = opts[rnd.wnext(opts.size(), -1)];
                    if (!rnd.next(5)) swap(ai, bi);
                    println(ai, bi, si);
                    break;
                }
            }
        } else if (mode == "more") {
            int si;
            vector<int> opts;
            while (true) {
                si = rnd.wnext(s / 2, s, 10);
                opts.clear();
                for (int q = 1; q * q <= si; q++) {
                    if (si % q == 0) opts.push_back(si / q);
                }
                if (!opts.empty()) {
                    int ai = opts[rnd.wnext(opts.size(), 1)], bi = opts[rnd.next(opts.size())];
                    if (!rnd.next(5)) swap(ai, bi);
                    println(ai, bi, si);
                    break;
                }
            }
        }
    }
}
