#include <bits//stdc++.h>

#define ll long long
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
#define ld long double


const int mod = 1e9 + 9;
const int inf = 1e9 + 1;


using namespace std;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


ll rnd(ll l, ll r) {
    uniform_int_distribution<ll> range(l, r);
    return range(rng);
}


template <class T>
istream& operator>>(istream &in, vector<T> &arr) {
    for (T &x : arr) {
        in >> x;
    }
    return in;
}


// a <= b!!!
ll solveBigA(ll a, ll b, ll s) {
    ll answer = 0;
    for (ll x = 0; x * a <= s; x++) {
        answer += (s - x * a) / b + 1;
    }
    return answer;
}


ll gcd(ll a, ll b, ll & x, ll & y) {
    if (a == 0) {
        x = 0; y = 1;
        return b;
    }
    ll x1, y1;
    ll d = gcd(b%a, a, x1, y1);
    x = y1 - (b / a) * x1;
    y = x1;
    return d;
}


// -1 if no inv
ll findInverse(ll a, ll m) {
    ll x, y;
    ll g = gcd(a, m, x, y);
    if (g != 1)
        return -1;
    else {
        x = (x % m + m) % m;
        return x;
    }
}


// how many x: bx = c(mod m) && x <= t
ll countSolutionsLeqT(ll b, ll c, ll m, ll t) {
    ll g = __gcd(b, m);
    if (c % g != 0) {
        return 0;
    }

   return g * (t / m); // all blocks have exactly g solutions
}


ll solveSmallA(ll a, ll b, ll s) {
    ll maxT = s / b;
    ll innerSum = s * (maxT + 1) - b * maxT * (maxT + 1) / 2;
    for (ll x = 1; x < a; x++) {
        innerSum -= x * countSolutionsLeqT(b, s - x, a, maxT);
    }
    for (ll t = (maxT / a) * a; t <= maxT; t++) { // check all lost by upper function
        innerSum -= (s - b * t) % a;
    }
    return innerSum / a + maxT + 1; // We can do no b step down + we can do no move at all
}

void solve() {
    int a, b, s;
    cin >> a >> b >> s;
    if (a > b) {
        swap(a, b);
    }
    if (a > s / a) {
        cout << solveBigA(a, b, s) << "\n";
    } else {
        cout << solveSmallA(a, b, s) << "\n";
    }
}


//void stress(ll a, ll b, ll s) {
//    ll unk = solveSmallA(a, b, s), ok = solveBigA(a, b, s);
//    if (unk != ok) {
//        cerr << "WA on test: " << a << " " << b << " " << s << endl;
//        cerr << "Got " << unk << ", but " << ok << " expected" << endl;
//        exit(0);
//    }
//    cerr << "Test passed!" << endl;
//}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(10);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
//    for (int i = 0; i < 1e7; i++) {
//        stress(rnd(1, 1e4), rnd(1, 1e4), rnd(1, 1e4));
//    }
    return 0;
}