#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);
    int group = validator.group() == "" ? -1 : atoi(validator.group().c_str());

    int n = inf.readInt(1, 1000'000, "n");
    inf.readEoln();
    int lim = 1e9;
    auto b = inf.readInts(n, -lim, lim, "b");
    inf.readEoln();

    int cnt = 0;
    switch (group) {
        case 1:
            ensuref(n <= 5, "n greater than 5");
            for (int bi: b) ensuref(bi <= 10, "bi greater than 10");
            break;
        case 2:
            for (int t = 2; t * t <= n; t++)
                ensuref(n % t != 0, "not prime");
            break;
        case 3:
            ensuref(__builtin_popcount(n) == 1, "not a power of 2");
            break;
        case 4:
            for (int bi : b) if (bi != 0) cnt++;
            ensuref(cnt <= 10, "non-zero bi too many");
            break;
        case 5:
            ensuref(n <= 1000, "n greater than 1000");
            break;
        case 6:
            ensuref(n <= 100000, "n greater than 10^5");
            break;
    }

    inf.readEof();

}