using namespace std;

#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

typedef long long ll;

const ll max_n = 100000;
const ll max_a = 1000000000;

/*
1. sum(t_i) до 5, k = 1, все b_i до 5 (полный перебор что когда продать)
2. k = 1, все t_i = 1, все b_i различны (продать все в последний день)
3. все b_i равны между собой (продавать по максимуму ближе к концу)
4. все t_i = 1 (чуть проще, чем фулл)
5. все b_i до 10^5 (видимо идти с конца по дням чуть проще, можно идти по всем дням, а не между соседними b_i)
6. фулл (n до 10^5, все остальное до 10^9, sum(t_i) до 10^9, чтобы не переполниться)
 */

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, max_n, "n");
    inf.readSpace();
    int k = inf.readInt(1, max_a, "k");
    inf.readEoln();
    vector<int> a(n), b(n), t(n);
    ll suma = 0, sumb = 0, sumt = 0;
    for (int i = 0; i < n; i++) {
        t[i] = inf.readInt(1, max_a, "t");
        inf.readSpace();
        a[i] = inf.readInt(1, 10000, "a");
        inf.readSpace();
        b[i] = inf.readInt(1, max_a, "b");
        inf.readEoln();
        sumt += t[i];
        suma += a[i];
        sumb += b[i];
    }
    ensuref(sumb <= max_a, "sum B > 1e9");
    if (validator.group() == "1") {
        /*
         1. sum(t_i) до 5, k = 1, все b_i до 5 (полный перебор что когда продать)
         */
        ensuref(sumb <= 5, "Sum B");
        ensuref(k == 1, "k != 1");
        ensuref(*max_element(t.begin(), t.end()) <= 5, "Max T > 5");
    }
    if (validator.group() == "2") {
        /*
         2. k = 1, все t_i = 1, все b_i различны (продать все в последний день)
         */
        ensuref(k == 1, "k != 1");
        ensuref(*max_element(b.begin(), b.end()) == 1, "Max B != 1");
        set<int> s;
        for (auto i : t) {
            s.insert(i);
        }
        ensuref(s.size() == n, "not different");
    }
    if (validator.group() == "3") {
        /*
         3. все b_i равны между собой (продавать по максимуму ближе к концу)
         */
        ensuref(*max_element(t.begin(), t.end()) == *min_element(t.begin(), t.end()), "Max T != Min T");
    }
    if (validator.group() == "4") {
        /*
        4. все t_i = 1 (чуть проще, чем фулл)
         */
        ensuref(*max_element(b.begin(), b.end()) == 1, "Max B != 1");
    }
    if (validator.group() == "5") {
        /*
        5. все b_i до 10^5 (видимо идти с конца по дням чуть проще, можно идти по всем дням, а не между соседними b_i)
         */
        ensuref(*max_element(t.begin(), t.end()) <= 1e5, "max T > 1e5");
    }
    inf.readEof();

    return 0;
}
