using namespace std;

#include <iostream>
#include <unordered_set>
#include <queue>
#include "testlib.h"

typedef long long ll;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int max_n = opt<int>("n");
    int max_n_w = opt<int>("nw");
    int max_m = opt<int>("m");
    int max_m_w = opt<int>("mw");
    int comp_w = opt<int>("cw");
    ll max_b = opt<ll>("b");
    ll max_c = opt<ll>("c");
    ll max_w = opt<ll>("w");
    ll w_no0_w = opt<int>("uw");
    bool is_bamboo = opt<bool>("bamboo");
    bool b_max = opt<bool>("bmax");

    int n = 2 + rnd.wnext(max_n - 1, max_n_w);
    int m = 2 + rnd.wnext(max_m - 1, max_m_w);

    vector<int> parent(n);
    vector <vector<int>> tree(n);
    vector <ll> ws(n + 1);
    vector < pair < pair < int, int >, ll >> edges;
    for (int i = 1; i < n; ++i) {
        int p = is_bamboo ? i - 1 : (0 + rnd.wnext(i, comp_w));
        parent[i] = p;
        ll w = (rnd.wnext(3LL, w_no0_w) == 0) ? 0 : rnd.next(1LL, max_w);
        edges.emplace_back(make_pair(i, p), w);
    }
    shuffle(edges.begin(), edges.end());

    vector<int> nodes_perm = rnd.perm(n), edges_inv_perm(n);
    for (int i = 0; i < n; ++i) { edges_inv_perm[nodes_perm[i]] = i; }

    printf("%d %d %lld\n", n, m, b_max ? max_b : rnd.next(1LL, max_b));

    for (int i = 0; i < n - 1; ++i) {
        int u = nodes_perm[edges[i].first.first] + 1;
        int v = nodes_perm[edges[i].first.second] + 1;
        printf("%d %d %lld\n", u, v, edges[i].second);
    }

    for (int i = 0; i < m; ++i) {
        int u = rnd.next(1, n);
        int v = rnd.next(1, n - 1);
        v = v < u ? v : v + 1;
        ll c = rnd.next(1LL, max_c);
        printf("%d %d %lld\n", u, v, c);
    }
    return 0;
}
