import java.math.BigInteger
import kotlin.math.log2

data class task(val u: Int, val v: Int, val p: Int, val c: Long)
data class MutablePair<T, U>(var first: T, var second: U)

fun make_tree(
    g: MutableList<MutableList<MutablePair<Int, Long>>>,
    tree: MutableList<MutablePair<Int, MutablePair<Int, Long>>>,
    v: Int,
    p: Int
) {
    for (pp in g[v]) {
        if (pp.first == p) {
            continue;
        }
        tree[pp.first].first = v
        tree[pp.first].second.first = tree[v].second.first + 1
        tree[pp.first].second.second = pp.second
        make_tree(g, tree, pp.first, v);
    }
}

fun lca(
    tree: MutableList<MutablePair<Int, MutablePair<Int, Long>>>,
    ups: MutableList<MutableList<Int>>,
    up: Int,
    vp: Int
): Int {
    var u = up;
    var v = vp;
    if (tree[v].second.first > tree[u].second.first) {
        val t = v
        v = u
        u = t
    }
    for (i in ups[0].size - 1 downTo 0) {
        if (tree[ups[u][i]].second.first - tree[v].second.first >= 0) {
            u = ups[u][i]; }
    }
    if (v == u) {
        return v; }
    for (i in ups[0].size - 1 downTo 0) {
        if (ups[v][i] != ups[u][i]) {
            v = ups[v][i];
            u = ups[u][i];
        }
    }
    return tree[v].first;
}

fun recalc_tree(
    g: MutableList<MutableList<MutablePair<Int, Long>>>,
    dp: MutableList<MutablePair<BigInteger, BigInteger>>,
    v: Int,
    p: Int
) {
    for (pp in g[v]) {
        if (pp.first == p) {
            continue; }
        recalc_tree(g, dp, pp.first, v);
        dp[v].first += dp[pp.first].first;
        dp[v].second += dp[pp.first].second;
    }
}


fun solver(): BigInteger {
    val fLine = readLine()!!.split(" ")
    val n = fLine[0].toInt()
    val m = fLine[1].toInt()
    val B = fLine[2].toLong().toBigInteger()
    val g = MutableList(n + 1) {
        MutableList(0) {
            MutablePair(
                0,
                0L
            )
        }
    } //vector<pair<int, ll>>());  // vector<vector<pair<int, ll>>>
    val logn = log2(n.toDouble()).toInt() + 1;
    val ups = MutableList(n + 1) { MutableList(logn + 1) { 0 } }
    val tree = MutableList(n + 1) { MutablePair(0, MutablePair(0, 0L)) } //vector<pair<int, pair<int, ll>>>
    for (i in 0 until n - 1) {
        val lin = readLine()!!.split(" ")
        val u = lin[0].toInt()
        val v = lin[1].toInt()
        val w = lin[2].toLong()
        g[u].add(MutablePair(v, w));
        g[v].add(MutablePair(u, w));
    }
    make_tree(g, tree, 1, 0);
    for (i in 1..n) {
        ups[i][0] = if (tree[i].first == 0) i else tree[i].first; }
    for (j in 1..logn) {
        for (i in 1..n) {
            ups[i][j] = ups[ups[i][j - 1]][j - 1]; }
    }
    val ans = MutableList(n + 1) { MutablePair(BigInteger.ZERO, BigInteger.ZERO) } //vector<pair<ll, ll>> from down, from up
    for (i in 0 until m) {
        val lin = readLine()!!.split(" ")
        val u = lin[0].toInt()
        val v = lin[1].toInt()
        val c = lin[2].toLong()
        val p = lca(tree, ups, u, v);

        ans[u].first += c.toBigInteger();
        ans[p].first -= c.toBigInteger();
        ans[v].second += c.toBigInteger();
        ans[p].second -= c.toBigInteger();
    }
    recalc_tree(g, ans, 1, 0);
    var s = BigInteger.ZERO
    for (i in 1..n) {
        if (tree[i].first == 0 || tree[i].second.second == 0L) {
            continue; }
        s += (ans[i].first + B - BigInteger.ONE) / B * tree[i].second.second.toBigInteger()
        s += (ans[i].second + B - BigInteger.ONE) / B * tree[i].second.second.toBigInteger()
    }
    return s
}


fun main() {
//    println("here")
    println(solver())
}