using namespace std;

#include <bits/stdc++.h>

#define ll long long
#define ull unsigned ll
#define ld long double
#define pb push_back
#define mp make_pair
#define fori(i, n) for (int i = 0; i < n; ++i)
#define fori1(i, n) for (int i = 1; i <= n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sqr(x) (x)*(x)
#define db_(x) cout << x << ' ';
#define db(x) cout << x << '\n';
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);

struct task {
    int u, v, p;
    ll c;
    vector<int> dpath;
};

void make_tree(const vector<vector<pair<int, ll>>> &g, vector<pair<int, pair<int, ll>>> &tree, int v, int p) {
    for (auto pp : g[v]) {
        if (pp.first == p) { continue; }
        tree[pp.first].first = v;
        tree[pp.first].second.first = tree[v].second.first + 1;
        tree[pp.first].second.second = pp.second;
        make_tree(g, tree, pp.first, v);
    }
}

int lca(const vector<pair<int, pair<int, ll >>> &tree, const vector<vector<int>> &ups, int u, int v) {
    if (tree[v].second.first > tree[u].second.first) { swap(v, u); }
    for (int i = (int) ups[0].size() - 1; i >= 0; --i) {
        if (tree[ups[u][i]].second.first - tree[v].second.first >= 0) { u = ups[u][i]; }
    }
    if (v == u) { return v; }
    for (int i = (int) ups[0].size() - 1; i >= 0; --i) {
        if (ups[v][i] != ups[u][i]) {
            v = ups[v][i];
            u = ups[u][i];
        }
    }
    return tree[v].first;
}

bool find_down_path(const vector<vector<pair<int, ll>>> &g, vector<int> &path, int v, int p, int target) {
    if (v == target) { return true; }
    for (auto pp : g[v]) {
        if (pp.first == p) { continue; }
        if (find_down_path(g, path, pp.first, v, target)) {
            path.pb(pp.first);
            return true;
        }
    }
    return false;
}

void dfs_up(const vector<vector<pair<int, ll>>> &g, const vector<pair<int, pair<int, ll >>> &tree,
            vector<pair<vector<task *>, vector<task *>>> &qq, vector<pair<ll, ll>> &ans, int v, int p) {
    for (auto pp : g[v]) {
        if (pp.first == p) { continue; }
        dfs_up(g, tree, qq, ans, pp.first, v);
    }
    while (!qq[v].first.empty()) {
        task *t = qq[v].first.back();
        qq[v].first.pop_back();
        if (v != t->p) {
            ans[v].first += t->c;
        }
        if (v == t->p) {
//            db("X " << v << " " << t->c)
            qq[v].second.push_back(t);
        } else {
//            db("U " << v << "->" << p << " " << t->c)
            qq[p].first.push_back(t);
        }
    }
}

void dfs_down(const vector<vector<pair<int, ll>>> &g,
              vector<pair<vector<task *>, vector<task *>>> &qq, vector<pair<ll, ll>> &ans, int v, int p) {
    while (!qq[v].second.empty()) {
        task *t = qq[v].second.back();
        qq[v].second.pop_back();
        if (v != t->p) {
            ans[v].second += t->c;
        }
        if (v != t->v) {
//            db("D " << v << "->" << t->dpath.back() << " " << t->c)
            qq[t->dpath.back()].second.push_back(t);
            t->dpath.pop_back();
        } else {
//            db(". " << v << t->c)
        }
    }
    for (auto pp : g[v]) {
        if (pp.first == p) { continue; }
        dfs_down(g, qq, ans, pp.first, v);
    }
}

ll solver() {
    int n, m;
    ll B;
    cin >> n >> m >> B;
    vector < vector < pair < int, ll > >> g(n + 1);
    int logn = (int) log2(n) + 1;
    vector <vector<int>> ups;
    fori(i, n + 1) {
        ups.emplace_back(logn + 1);
    }
    vector < pair < int, pair < int, ll >>> tree(n + 1);
    fori(i, n - 1) {
        int u, v;
        ll w;
        cin >> u >> v >> w;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
    }
    make_tree(g, tree, 1, 0);
    fori1(i, n) { ups[i][0] = tree[i].first == 0 ? i : tree[i].first; }
    fori1(j, logn) {
        fori1(i, n) { ups[i][j] = ups[ups[i][j - 1]][j - 1]; }
    }

    vector <pair<ll, ll>> ans(n + 1); // from down, from up
    vector < pair < vector < task * > , vector < task *>>> qq(n + 1);
    fori(i, m) {
        int u, v;
        ll c;
        cin >> u >> v >> c;
        int p = lca(tree, ups, u, v);

        task *t = new task();
        t->u = u;
        t->v = v;
        t->p = p;
        t->c = c;
        t->dpath = vector<int>();
        find_down_path(g, t->dpath, p, tree[p].first, v);
        qq[u].first.push_back(t);
    }
    dfs_up(g, tree, qq, ans, 1, 0);
    dfs_down(g, qq, ans, 1, 0);

    ll s = 0;
    fori1(i, n) {
        if (tree[i].first == 0 || tree[i].second.second == 0) { continue; }
        s += (ans[i].first + B - 1) / B * tree[i].second.second;
        s += (ans[i].second + B - 1) / B * tree[i].second.second;
    }
    cout << s << "\n";
}

int main() {
#ifdef _DEBUG_INPUT_FILE
    freopen("test.in", "r", stdin);
#endif
    int q = 1;
//    cin >> q;
    fori(i, q) {
//        cout << solver();
        solver();
//        cout << (solver() ? "Possible" : "Impossible");
//        cout << (solver() ? "Yes" : "No");
//        cout << '\n';
    }
}